<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use FM\Traits\TResponse;
use FM\Service\Fm00030000TarefasRecorrentesService;
use React\Promise\Promise;

class Fm00030000TarefasRecorrentesController extends FMCrud
{
    protected $Fm00030000TarefasRecorrentesService;

    use TResponse;

    public function __construct($crudService, $environment, Fm00030000TarefasRecorrentesService $Fm00030000TarefasRecorrentesService)
    {
        parent::__construct($crudService, $environment);
        $this->Fm00030000TarefasRecorrentesService = $Fm00030000TarefasRecorrentesService;
    }

    public function insertTarefasRecorrentes(Request $request)
    {
        try {
            $data = $this->Fm00030000TarefasRecorrentesService->insertTarefasRecorrentes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function verificarConflitos(Request $request): array
    {
        try {
            $data = $this->Fm00030000TarefasRecorrentesService->verificarConflitoEdicaoDeTarefas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
