<?php
namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Traits\TResponse;
use FM\Service\FmModeloPopService;

class FmModeloPopController {
    use TResponse;

    protected $FmModeloPopService;

    public function __construct(FmModeloPopService $FmModeloPopService) {
        $this->FmModeloPopService = $FmModeloPopService;
    }
    
    public function getModeloPop(Request $request) {
        try {
            $data = $this->FmModeloPopService->getModeloPop();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarModeloPop(Request $request)
    {
        try {
            $parametro = $request->getParameters();
            $this->FmModeloPopService->salvarModeloPop($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function AtualizarModeloPop(Request $request)
    {
        try {
            $parametro = $request->getParameters();
            $this->FmModeloPopService->salvarModeloPop($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirModeloPop(Request $request)
    {
        try {
            $data = $this->FmModeloPopService->excluirModeloPop($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarAnexoPop(Request $request)
    {
        try {
            $this->FmModeloPopService->deletarAnexoPop($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}