<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Fm0000000EquipesFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    // QUERY FRAME PRINCIPAL EQUIPES
    public function getEquipes()
    {
        $sql = "SELECT NREQUIPE, NMEQUIPE, IDATIVO FROM FCM_EQUIPE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function inserirEquipe($params)
    {
        $sql = "INSERT INTO FCM_EQUIPE (
            NREQUIPE, NMEQUIPE, IDATIVO, NRORG, CDOPERINCLUSAO,NRORGINCLUSAO, DTINCLUSAO
        ) VALUES (
            :NREQUIPE, :NMEQUIPE, :IDATIVO, :NRORG, :CDOPERINCLUSAO, :NRORGINCLUSAO, SYSDATE
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarEquipe($params)
    {
        $sql = "UPDATE FCM_EQUIPE 
                SET NMEQUIPE    = :NMEQUIPE,
                    CDOPERULTATU    = :CDOPERULTATU,
                    NRORGULTATU    = :NRORGULTATU,
                    IDATIVO        = :IDATIVO,
                    DTULTATU    = SYSDATE
              WHERE NREQUIPE    = :NREQUIPE";

        $this->connection->executeStatement($sql, $params);
    }

    public function getOperadorEquipe($params)
    {
        $sql = "SELECT NRRELACEQUIPEOPER, NREQUIPE, CDOPERADOR 
                   FROM FCM_RELACEQUIPEOPER
                  WHERE NREQUIPE = :NREQUIPE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function relacionarOperadorEquipe($params)
    {
        $sql = "INSERT INTO FCM_RELACEQUIPEOPER (
           NRRELACEQUIPEOPER, NREQUIPE, CDOPERADOR, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO, DTINCLUSAO
        ) VALUES (
            :NRRELACEQUIPEOPER, :NREQUIPE, :CDOPERADOR, :NRORG, :NRORGINCLUSAO, :CDOPERINCLUSAO, :IDATIVO, SYSDATE
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function excluirEquipes($parametro)
    {
        $sql = "DELETE FROM FCM_EQUIPE 
                 WHERE NREQUIPE IN (" . $parametro . ")";

        $this->connection->executeStatement($sql);
    }
    
    public function excluirOperadorEquipe($filtro)
    {
        $sql = "DELETE FROM FCM_RELACEQUIPEOPER
                $filtro";

        $this->connection->executeStatement($sql);
    }
}