<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Fm00004000TarefasFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    /* INTEGRAÇÃO COM SM */
    public function getContratos($parametros)
    {
        $sql = "SELECT FCM_RELACLOCALCONT.*,  FCT_CONTRATO.NRCONTRATOFCT
                    FROM FCM_RELACLOCALCONT
                        JOIN FCT_CONTRATO
                        ON FCT_CONTRATO.NRSEQCONTRATO = FCM_RELACLOCALCONT.NRSEQCONTRATO
                    WHERE ((FCM_RELACLOCALCONT.NRESTRUTURAM IN (:NRESTRUTURAM)) OR (FCM_RELACLOCALCONT.NRESTRUTURAM  IS NULL))";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    /* INTEGRAÇÃO COM SM */

    public function getTarefasGrid($parametros, $listaOperadores)
    {
        $sql = "SELECT 
                    FCM_CHECKLISTAGEND.NRCHECKLISTAGEND, 
                    FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, 
                    TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') AS DTHORAAGEND,
                    TO_CHAR(FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'DD/MM/YYYY HH24:MI') AS DTHRFINALAGEND,
                    TO_CHAR(FCM_CHECKLISTAGEND.DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS') AS DTINCLUSAO,
                    FCM_LOCALCLI.NRLOCALCLIENTE, 
                    FCM_LOCALCLI.NMLOCALCLIENTE, 
                    FCM_LOCALCLI.NRESTRUTURAM,
                    FCM_TIPOLOCALCLI.NRTIPOLOCALCLI,
                    FCM_TIPOLOCALCLI.NMTIPOLOCALCLI, 
                    FCT_CONTRATO.NRSEQCONTRATO,
                    FCM_CHECKLIST.NRCHECKLIST, 
                    FCM_CHECKLIST.NMCHECKLIST, 
                    FCM_CHECKLISTAGEND.IDTIPORECORRENCIA, 
                    FCM_CHECKLISTAGEND.IDSITUACAOAGEND,
                    FCM_CHECKLISTAGEND.CDOPERINCLUSAO,
                    OPERADOR.NMOPERADOR, 
                    FCM_CHECKLISTAGEND.CDOPERADOR, 
                    FCM_EQUIPE.NMEQUIPE,
                    FCM_EQUIPETAREFA.NREQUIPE,
                    FCM_EQUIPETAREFA.NREQUIPETAREFA,
                    FCM_LOCALCLI.CDCLIENTE, 
                    CLIENTE.NMRAZSOCCLIE,
                    CLIENTE.NMFANTCLIE, 
                    FCT_CONTRATO.NRCONTRATOFCT, 
                    FCM_CHECKLISTAGEND.IDATIVO, 
                    FCM_GERENCIAMENTOCHK.CDOPERADOR AS CDOPERADORPAI,
                    FCM_GERENCIAMENTOCHK.IDOBRIGAOBSERVACAO, 
                    FCM_CHECKLISTAGEND.IDTIPOMARCACAOTAREFA, 
                    FCM_CHECKLISTAGEND.NRPRIORIDADETAREFA, 
                    FCM_ATIVIDADECHK.NRATIVIDADECHK,
                    FCM_RELCHKAGENDMODPOP.NRMODELOPOP,
                    FCM_RELCHKAGENDMODPOP.DSOBSERVACAO,
                    (SELECT 
                        RTRIM(XMLAGG(XMLELEMENT(E, FCM_RELCHKAGENDEPI.NREPI || ', ').EXTRACT('//text()')).GETCLOBVAL(), ', ') 
                    FROM 
                        FCM_RELCHKAGENDEPI
                    WHERE 
                        FCM_RELCHKAGENDEPI.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                        AND FCM_RELCHKAGENDEPI.IDATIVO = 'S'
                    ) AS NREPI,
                    (SELECT 
                        LISTAGG(NRCRITERIOTAREFACHK, ', ') WITHIN GROUP (ORDER BY NRCRITERIOTAREFACHK) 
                    FROM 
                        FCM_RELCRITERIOTAGTAREFACHK
                    WHERE 
                        FCM_RELCRITERIOTAGTAREFACHK.NRTAREFACHK IN 
                            (SELECT NRTAREFACHK FROM FCM_TAREFACHK WHERE FCM_TAREFACHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST)
                    ) AS NRCRITERIOTAREFACHK,
                    (SELECT 
                        LISTAGG(NRTAREFACHK, ', ') WITHIN GROUP (ORDER BY NRTAREFACHK) 
                    FROM 
                        FCM_TAREFACHK 
                    WHERE 
                        FCM_TAREFACHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST
                    ) AS NRTAREFACHK
                FROM 
                    FCM_CHECKLISTAGEND
                JOIN 
                    FCM_LOCALCLI ON FCM_CHECKLISTAGEND.NRLOCALCLIENTE = FCM_LOCALCLI.NRLOCALCLIENTE
                JOIN 
                    CLIENTE ON CLIENTE.CDCLIENTE = FCM_LOCALCLI.CDCLIENTE
                JOIN 
                    FCM_TIPOLOCALCLI ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                JOIN 
                    FCM_CHECKLIST ON FCM_CHECKLISTAGEND.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
                LEFT JOIN 
                    FCM_GERENCIAMENTOCHK ON FCM_GERENCIAMENTOCHK.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                LEFT JOIN 
                    OPERADOR ON FCM_CHECKLISTAGEND.CDOPERADOR = OPERADOR.CDOPERADOR
                LEFT JOIN 
                    FCT_CONTRATO ON FCT_CONTRATO.NRSEQCONTRATO = FCM_CHECKLISTAGEND.NRSEQCONTRATO
                LEFT JOIN 
                    FCM_ATIVIDADECHK ON FCM_CHECKLISTAGEND.NRCHECKLIST = FCM_ATIVIDADECHK.NRCHECKLIST
                LEFT JOIN 
                    FCM_EQUIPETAREFA ON FCM_EQUIPETAREFA.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                LEFT JOIN 
                    FCM_EQUIPE ON FCM_EQUIPE.NREQUIPE = FCM_EQUIPETAREFA.NREQUIPE
                LEFT JOIN 
                    FCM_RELCHKAGENDMODPOP ON FCM_CHECKLISTAGEND.NRCHECKLISTAGEND = FCM_RELCHKAGENDMODPOP.NRCHECKLISTAGEND
                WHERE 
                    (
                        (FCM_CHECKLISTAGEND.CDOPERADOR IN ($listaOperadores)) -- Tarefas criadas para operador específico
                        OR ((FCM_CHECKLISTAGEND.CDOPERADOR IS NULL) AND (FCM_CHECKLISTAGEND.IDTAREFAEQUIPE = 'N')) -- Tarefas sem operador
                        OR (FCM_EQUIPETAREFA.NREQUIPE IN 
                            (SELECT DISTINCT FCM_EQUIPE.NREQUIPE 
                            FROM FCM_EQUIPE
                            JOIN FCM_RELACEQUIPEOPER ON FCM_RELACEQUIPEOPER.NREQUIPE = FCM_EQUIPE.NREQUIPE
                            AND FCM_RELACEQUIPEOPER.NRORG = FCM_EQUIPE.NRORG
                            WHERE FCM_RELACEQUIPEOPER.CDOPERADOR IN ($listaOperadores))
                        ) -- Tarefas de equipe
                        OR FCM_CHECKLISTAGEND.CDOPERINCLUSAO = :CDOPERADOR -- Operador de inclusão
                    )
                    AND FCM_CHECKLISTAGEND.IDATIVO = 'S'
                ORDER BY 
                    FCM_CHECKLISTAGEND.DTHORAAGEND DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros, [], [], null, null, null, array('NREPI'));
    }


    public function getClientes()
    {
        $sql = "SELECT CDCLIENTE, NMRAZSOCCLIE, NMFANTCLIE
                  FROM CLIENTE
                  WHERE IDCLIEATIV = 'S'
                      AND IDATIVO = 'S' 
                      AND CDCLIENTE IN (SELECT CDCLIENTE 
                                          FROM FCM_LOCALCLI
                                      WHERE IDATIVO = 'S')";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getLocal($param, $cliente)
    {

        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE, NRESTRUTURAM, NRTIPOLOCALCLI
                FROM FCM_LOCALCLI
                WHERE IDATIVO = 'S'
                AND NRTIPOLOCALCLI IN ($param)
                AND FCM_LOCALCLI.CDCLIENTE = $cliente";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTipoLocalTarefa($cliente)
    {

        $sql = "SELECT DISTINCT FCM_TIPOLOCALCLI.NRTIPOLOCALCLI, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI
                FROM FCM_TIPOLOCALCLI
                JOIN FCM_LOCALCLI
                ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                WHERE FCM_TIPOLOCALCLI.IDTIPOLOCALCLI = '3'
                AND FCM_TIPOLOCALCLI.IDATIVO = 'S'
                AND FCM_LOCALCLI.CDCLIENTE IN ($cliente)
                ORDER BY NMTIPOLOCALCLI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getChecklistTarefa($param)
    {
        $sql = "SELECT NRCHECKLIST, 
                       NMCHECKLIST
                  FROM FCM_CHECKLIST
                  WHERE IDATIVO = 'S'
                    AND NRTIPOLOCALCLI IN ($param)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getItensChecklist($parametros)
    {
        $sql = "SELECT FCM_ATIVIDADECHK.NRATIVIDADECHK, FCM_ATIVIDADE.NMATIVIDADE 
        FROM FCM_ATIVIDADE
        JOIN FCM_ATIVIDADECHK
        ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
        JOIN FCM_CHECKLIST
        ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
        WHERE FCM_ATIVIDADE.IDATIVO = 'S' 
          AND FCM_CHECKLIST.NRCHECKLIST = " . $parametros['NRCHECKLIST'];

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEscopo()
    {
        $sql = "SELECT DISTINCT FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA, FCM_ESCOPOSTAREFA.NMESCOPOSTAREFA, FCM_ATIVIDADECHK.NRATIVIDADECHK
                  FROM FCM_ESCOPOSTAREFA
                  LEFT JOIN FCM_TAGSTAREFA
                  ON FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA = FCM_TAGSTAREFA.NRESCOPOSTAREFA
                  LEFT JOIN FCM_TAGSCHKTAREFA
                  ON FCM_TAGSTAREFA.NRTAGSTAREFA = FCM_TAGSCHKTAREFA.NRTAGSTAREFA
                  LEFT JOIN FCM_TAREFACHK
                  ON FCM_TAREFACHK.NRTAREFACHK = FCM_TAGSCHKTAREFA.NRTAREFACHK
                  LEFT JOIN FCM_ATIVIDADECHK
                  ON FCM_ATIVIDADECHK.NRATIVIDADECHK = FCM_TAREFACHK.NRATIVIDADECHK
                  WHERE FCM_ESCOPOSTAREFA.IDATIVO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTarefasSelect($param)
    {
        $sql = "SELECT A.NRTAREFACHK, C.NMTAREFA, C.NRPRIORIDADETAREFA, P.IDPRIORIDADE
                  FROM FCM_TAREFACHK A
                  JOIN FCM_ATIVIDADECHK B
                  ON A.NRATIVIDADECHK = B.NRATIVIDADECHK
                  JOIN FCM_TAREFA C
                  ON A.NRTAREFA = C.NRTAREFA
                  LEFT JOIN FCM_PRIORIDADETAREFA P
                  ON P.NRPRIORIDADETAREFA = C.NRPRIORIDADETAREFA
                  WHERE C.IDATIVO = 'S'
                  AND B.NRATIVIDADECHK IN ($param)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getCriterios($param)
    {
        $sql = "SELECT A.NRCRITERIOTAREFACHK, A.NRCRITERIOTAREFA,B.DSCRITERIOTAREFA, A.NRTAREFACHK, E.NRCHECKLIST, D.NRATIVIDADECHK, F.NMTAREFA
                  FROM FCM_CRITERIOTAREFACHK A
                  JOIN FCM_CRITERIOTAREFA B
                    ON A.NRCRITERIOTAREFA = B.NRCRITERIOTAREFA
                  JOIN FCM_TAREFACHK C
                    ON A.NRTAREFACHK = C.NRTAREFACHK
                  JOIN FCM_ATIVIDADECHK D
                    ON C.NRATIVIDADECHK = D.NRATIVIDADECHK
                  JOIN FCM_CHECKLIST E
                    ON E.NRCHECKLIST = D.NRCHECKLIST
                  JOIN FCM_TAREFA F
                  ON C.NRTAREFA = F.NRTAREFA
                 WHERE B.IDATIVO = 'S'
                   AND A.NRTAREFACHK IN (" . $param['NRTAREFACHK'] . ")
                   AND E.NRCHECKLIST  = " . $param['NRCHECKLIST'] . "
                   AND D.NRATIVIDADECHK IN (" . $param['NRATIVIDADECHK'] . ")";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getFuncionario($locais)
    {
        $sql = "SELECT DISTINCT OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR
                    FROM OPERADOR
                    JOIN FCM_FUNCIONARIOSHIERARQ
                    ON FCM_FUNCIONARIOSHIERARQ.CDOPERADOR = OPERADOR.CDOPERADOR
                    JOIN FCM_HIERARQUIAFUNC
                    ON FCM_HIERARQUIAFUNC.NRHIERARQUIAFUNC = FCM_FUNCIONARIOSHIERARQ.NRHIERARQUIAFUNC
                LEFT JOIN FCM_RELACHABOPER 
                    ON FCM_RELACHABOPER.CDOPERADOR = OPERADOR.CDOPERADOR
                LEFT JOIN  FCM_RELACHABATIV
                    ON  FCM_RELACHABATIV.NRHABILIDADE = FCM_RELACHABOPER.NRHABILIDADE
                    LEFT JOIN FCM_TAREFACHK
                    ON FCM_TAREFACHK.NRTAREFA = FCM_RELACHABATIV.NRTAREFA
                WHERE FCM_HIERARQUIAFUNC.NRLOCALCLIENTE IN (SELECT NRLOCALCLIENTE
                                                                FROM FCM_LOCALCLI
                                                            START WITH NRLOCALCLIENTE IN ($locais)
                                                            CONNECT BY PRIOR NRLOCALCLIENTEPAI = NRLOCALCLIENTE)";


        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
   
    public function getEpis()
    {
        $sql = "SELECT NREPI, NMEPI, IDATIVO, NRORG 
                        FROM FCM_EPI"; 
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEquipeTarefa($locais) 
    {
        $sql = "SELECT DISTINCT FCM_EQUIPE.NREQUIPE, FCM_EQUIPE.NMEQUIPE 
                    FROM FCM_EQUIPE
                    JOIN FCM_RELACEQUIPEOPER 
                    ON FCM_RELACEQUIPEOPER.NREQUIPE = FCM_EQUIPE.NREQUIPE
                    JOIN FCM_FUNCIONARIOSHIERARQ
                    ON FCM_FUNCIONARIOSHIERARQ.CDOPERADOR = FCM_RELACEQUIPEOPER.CDOPERADOR
                    JOIN FCM_HIERARQUIAFUNC
                    ON FCM_HIERARQUIAFUNC.NRHIERARQUIAFUNC = FCM_FUNCIONARIOSHIERARQ.NRHIERARQUIAFUNC
                    WHERE FCM_HIERARQUIAFUNC.NRLOCALCLIENTE IN (SELECT NRLOCALCLIENTE
                                                                FROM FCM_LOCALCLI
                                                            START WITH NRLOCALCLIENTE IN ($locais)
                                                            CONNECT BY PRIOR NRLOCALCLIENTEPAI = NRLOCALCLIENTE)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getModeloPop()
    {
        $sql = "SELECT NRMODELOPOP, NMMODELOPOP, IDATIVO, NRORG 
                    FROM FCM_MODELOPOP"; 

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function salvarEdicaoTarefas(array $params): void
    {
        $sql = "UPDATE FCM_CHECKLISTAGEND 
                        SET 
                            NMCHECKLISTAGEND = :NMCHECKLISTAGEND,
                            CDOPERADOR = :CDOPERADOR,
                            DTHORAAGEND = :DTHORAAGEND,
                            DTHRFINALAGEND = :DTHRFINALAGEND,
                            NRPRIORIDADETAREFA = :NRPRIORIDADETAREFA
                        WHERE 
                            NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        $this->connection->executeStatement($sql, $params);
    }

    public function getSupervisorTarefa($locais, $operadores)
    {
        $sql = "SELECT DISTINCT OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR
                        FROM OPERADOR
                        JOIN FCM_FUNCIONARIOSHIERARQ
                        ON FCM_FUNCIONARIOSHIERARQ.CDOPERADOR = OPERADOR.CDOPERADOR
                        JOIN FCM_HIERARQUIAFUNC
                        ON FCM_HIERARQUIAFUNC.NRHIERARQUIAFUNC = FCM_FUNCIONARIOSHIERARQ.NRHIERARQUIAFUNC
                    WHERE FCM_FUNCIONARIOSHIERARQ.CDOPERADOR IN (SELECT CDOPERADORPAI
                                                                    FROM FCM_FUNCIONARIOSHIERARQ
                                                                    WHERE CDOPERADORPAI IS NOT NULL
                                                                    START WITH CDOPERADOR IN ($operadores)
                                                                    CONNECT BY PRIOR CDOPERADORPAI = CDOPERADOR)
                        AND FCM_HIERARQUIAFUNC.NRLOCALCLIENTE IN (SELECT NRLOCALCLIENTE
                                                FROM FCM_LOCALCLI
                                                START WITH NRLOCALCLIENTE IN ($locais)
                                                CONNECT BY PRIOR NRLOCALCLIENTEPAI = NRLOCALCLIENTE)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function validaCriterio($parametros)
    {

        $sql = "SELECT COUNT(*) AS VALIDA
                  FROM FCM_CRITERIOTAREFACHK 
                 WHERE NRTAREFACHK = :NRTAREFACHK
                   AND NRCRITERIOTAREFA = :NRCRITERIOTAREFA";


        $resultado = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $resultado[0]['VALIDA'];
    }

    public function insertChecklist($params)
    {

        $sql = "INSERT INTO FCM_CHECKLISTAGEND (
                                NRCHECKLISTAGEND, NMCHECKLISTAGEND, NRLOCALCLIENTE, 
                                NRCHECKLIST, CDOPERADOR, IDSITUACAOAGEND, 
                                DTHORAAGEND,  IDATIVO, DTINCLUSAO, 
                                DTHRFINALAGEND, CDOPERINCLUSAO, IDOBRIGAOBSERVACAO, NRSEQCONTRATO, IDTIPOMARCACAOTAREFA, IDTIPORECORRENCIA, NRPRIORIDADETAREFA, IDTAREFAEQUIPE)
                     VALUES (
                            :NRCHECKLISTAGEND, :NMCHECKLISTAGEND, :NRLOCALCLIENTE, 
                            :NRCHECKLIST, :CDOPERADOR, :IDSITUACAOAGEND,
                            :DTHORAAGEND, 'S', SYSDATE, 
                            :DTHRFINALAGEND, :CDOPERINCLUSAO, :IDOBRIGAOBSERVACAO, :NRSEQCONTRATO, :IDTIPOMARCACAOTAREFA, :IDTIPORECORRENCIA, :NRPRIORIDADETAREFA, :IDTAREFAEQUIPE)";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertTarefa($params)
    {
        $sql = "INSERT INTO FCM_TAREFAAGEND (
                                NRTAREFAAGEND, NRCHECKLISTAGEND, NRTAREFACHK, 
                                CDOPERADOR, DTHORATAREFAAGEND, DSOBSTAREFAAGEND, 
                                IDREALIZADO,  IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO, NRTAREFARECORRENTE
            )
            VALUES (
                    :NRTAREFAAGEND, :NRCHECKLISTAGEND, :NRTAREFACHK, 
                    :CDOPERADOR, :DTHORAAGEND, :DSOBSTAREFAAGEND, 
                    'N',  'S', SYSDATE, :CDOPERINCLUSAO, :NRTAREFARECORRENTE)";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertCriterio($params)
    {

        $sql = "INSERT INTO FCM_CRITERIOTARAGEND (
                                NRCRITERIOTARAGEND, NMCRITERIOTARAGEND, NRTAREFAAGEND, 
                                NRCRITERIOTAREFACHK, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO
            )
                    VALUES (
                        :NRCRITERIOTARAGEND,:NMCRITERIOTARAGEND, :NRTAREFAAGEND, 
                        :NRCRITERIOTAREFACHK, 'S', SYSDATE, 
                        :OPERADOR
                    )";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertChk($params)
    {
        $sql = "INSERT INTO FCM_GERENCIAMENTOCHK (
                                NRGERENCIAMENTOCHK, NMGERENCIAMENTOCHK, NRLOCALCLIENTE, 
                                NRCHECKLIST, CDOPERADOR, IDSITUACAOGERCHK, 
                                DTHORAAGEND, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO, NRCHECKLISTAGEND,DTHRFINALAGEND, IDOBRIGAOBSERVACAO, NRSEQCONTRATO)
                VALUES (
                    :NRGERENCIAMENTOCHK, :NMGERENCIAMENTOCHK, :NRLOCALCLIENTE, 
                    :NRCHECKLIST, :CDOPERADOR, '1',  
                    :DTHORAAGEND, 'S', SYSDATE, 
                    :OPERADOR, :NRCHECKLISTAGEND,TO_DATE(:DTHRFINALAGEND), :IDOBRIGAOBSERVACAO, :NRSEQCONTRATO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertChkHistorico($parametros)
    {
        $sql = "INSERT INTO FCM_GERCHKHISTORICO (
                    NRGERCHKHISTORICO,      NRGERENCIAMENTOCHK, NMGERENCIAMENTOCHK, DSGERENCIAMENTOCHK,
                    DTHISTGERENCIAMENTOCHK, IDTIPOHISTORICO,    IDATIVO,            NRORG,
                    DTINCLUSAO,             CDOPERINCLUSAO,     NRORGINCLUSAO,      DTULTATU,
                    CDOPERULTATU,           NRORGULTATU
                )
                VALUES (
                    :NRGERCHKHISTORICO,     :NRGERENCIAMENTOCHK, :NMGERENCIAMENTOCHK, :DSGERENCIAMENTOCHK,
                    SYSDATE,                :IDTIPOHISTORICO,    'S',                 :NRORG,
                    SYSDATE,                :CDOPERINCLUSAO,     :NRORGINCLUSAO,      SYSDATE,
                    :CDOPERULTATU,          :NRORGULTATU
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizaHistoricoTarefa($parametros)
    {
        $sql = "INSERT INTO FCM_CHKAGENDHISTORICO (
                    NRCHKAGENDHISTORICO,    NRCHECKLISTAGEND,   NMCHECKLISTAGEND,   DSCHKAGENDHISTORICO,
                    DTCHKAGENDHISTORICO,    IDTIPOHISTORICO,    IDATIVO,            NRORG,
                    DTINCLUSAO,             CDOPERINCLUSAO,     NRORGINCLUSAO,      DTULTATU,
                    CDOPERULTATU,           NRORGULTATU
                )
                VALUES (
                    :NRCHKAGENDHISTORICO,   :NRCHECKLISTAGEND,  :NMCHECKLISTAGEND,  :DSCHKAGENDHISTORICO,
                    SYSDATE,                :IDTIPOHISTORICO,   'S',                :NRORG,
                    SYSDATE,                :CDOPERINCLUSAO,    :NRORGINCLUSAO,     SYSDATE,
                    :CDOPERULTATU,          :NRORGULTATU
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function insertChkTarefa($params)
    {
        $sql = "INSERT INTO FCM_TAREFAGERCHK (
            NRTAREFAGERCHK, NRGERENCIAMENTOCHK, NRTAREFACHK, 
            CDOPERADOR, DTHORATAREFAGERCHK, DSOBSTAREFAGERCHK, 
            IDATIVO, DTINCLUSAO,  CDOPERINCLUSAO
            )
 VALUES (
    :NRTAREFAGERCHK, :NRGERENCIAMENTOCHK, :NRTAREFACHK, 
    :CDOPERADOR, :DTHORATAREFAGERCHK, :DSOBSTAREFAGERCHK, 
    'S', SYSDATE, :OPERADOR
    )";

        $this->connection->executeStatement($sql, $params);
    }
    public function insertChkCriterio($params)
    {
        $sql = "INSERT INTO FCM_CRITERIOTARGERCHK (
                                NRCRITERIOTARGERCHK, NMCRITERIOTARGERCHK, NRTAREFAGERCHK, 
                                NRCRITERIOTAREFACHK, IDATIVO, DTINCLUSAO, 
                                CDOPERINCLUSAO
                )
                     VALUES (
                        :NRCRITERIOTARGERCHK, :NMCRITERIOTARGERCHK,
                        :NRTAREFAGERCHK, :NRCRITERIOTAREFACHK,  'S', 
                        SYSDATE, :OPERADOR
                    )";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertEpis($params)
    {
        $sql = "INSERT INTO FCM_RELCHKAGENDEPI (
            NRRELCHKAGENDEPI, NREPI, NRCHECKLISTAGEND, IDATIVO, DTINCLUSAO, CDOPERINCLUSAO, DTULTATU
        )
        VALUES (
            :NRRELCHKAGENDEPI, :NREPI, :NRCHECKLISTAGEND, 'S', 
             SYSDATE, :CDOPERINCLUSAO,  SYSDATE
        )";
         $this->connection->executeStatement($sql, $params);
    }

    public function insertModeloPop($params)
    {
        $sql = "INSERT INTO FCM_RELCHKAGENDMODPOP (
                    NRRELCHKAGENDMODPOP, NRMODELOPOP, NRCHECKLISTAGEND, DSOBSERVACAO, 
                    IDATIVO, NRORG, DTINCLUSAO, 
                    CDOPERINCLUSAO, NRORGINCLUSAO, DTULTATU, CDOPERULTATU, NRORGULTATU
                )
                VALUES (
                    :NRRELCHKAGENDMODPOP, :NRMODELOPOP, :NRCHECKLISTAGEND, :DSOBSERVACAO, 
                    'S', :NRORG, SYSDATE, 
                    :CDOPERINCLUSAO, :NRORGINCLUSAO, SYSDATE, :CDOPERULTATU, :NRORGULTATU
                )";
                $this->connection->executeStatement($sql, $params);
    }

    public function deletarTarefas($param)
    {
        $sql = "UPDATE FCM_CHECKLISTAGEND
                 SET IDATIVO  = 'N'
                 WHERE NRCHECKLISTAGEND IN (" . $param . ")";

        $this->connection->executeStatement($sql);

        $sql1 = "UPDATE FCM_GERENCIAMENTOCHK
                 SET IDATIVO  = 'N'
                 WHERE NRCHECKLISTAGEND IN (" . $param . ")";

        $this->connection->executeStatement($sql1);

    }

    public function deletarEpis($parametros)
    {
        $sql = "DELETE
                FROM FCM_RELCHKAGENDEPI
                WHERE NRCHECKLISTAGEND IN (" . $parametros . ")";

        $this->connection->executeStatement($sql);

        $sql1 = "DELETE
                FROM FCM_RELCHKAGENDMODPOP
                WHERE NRCHECKLISTAGEND IN (" . $parametros . ")";

        $this->connection->executeStatement($sql1);
    }

    public function deletarModpop($parametros)
    {
        $sql1 = "DELETE
                FROM FCM_RELCHKAGENDMODPOP
                WHERE NRCHECKLISTAGEND IN (" . $parametros . ")";

        $this->connection->executeStatement($sql1);
    }


    public function getTarefasSelectAll()
    {
        $sql = "SELECT A.NRTAREFACHK, C.NMTAREFA
                  FROM FCM_TAREFACHK A
                  JOIN FCM_ATIVIDADECHK B
                  ON A.NRATIVIDADECHK = B.NRATIVIDADECHK
                  JOIN FCM_TAREFA C
                  ON A.NRTAREFA = C.NRTAREFA
                  WHERE C.IDATIVO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function populaEscopo($param)
    {
        $sql = "SELECT DISTINCT E.NMESCOPOSTAREFA
                           FROM FCM_CHECKLISTAGEND CA
                     INNER JOIN FCM_GERENCIAMENTOCHK GC ON CA.NRCHECKLIST = GC.NRCHECKLIST
                     INNER JOIN FCM_ESCOPOSTAREFACHK EC ON GC.NRCHECKLIST = EC.NRCHECKLIST
                     INNER JOIN FCM_ESCOPOSTAREFA E ON EC.NRESCOPOSTAREFA = E.NRESCOPOSTAREFA
                          WHERE CA.NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $param);
    }

    public function getAtividade($param)
    {
        $sql = "SELECT T.NMTAREFA
                  FROM FCM_CHECKLISTAGEND CA
            INNER JOIN FCM_GERENCIAMENTOCHK GC ON CA.NRCHECKLIST = GC.NRCHECKLIST
            INNER JOIN FCM_ATIVIDADECHK AC ON GC.NRCHECKLIST = AC.NRCHECKLIST
            INNER JOIN FCM_ATIVIDADE A ON AC.NRATIVIDADE = A.NRATIVIDADE
            INNER JOIN FCM_TAREFA T ON A.NRATIVIDADE = T.NRATIVIDADE
                 WHERE CA.NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $param);
    }

    public function populaCriterios($nrTarefachk)
    {
        $sql = " SELECT NRCRITERIOTAREFACHK 
                    FROM FCM_CRITERIOTAREFACHK
                    WHERE NRTAREFACHK = $nrTarefachk";


        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getNrtarefachk($parametros)
    {
        $sql = "SELECT NRTAREFACHK 
                FROM FCM_TAREFACHK
                    WHERE NRCHECKLIST = :NRCHECKLIST 
                    AND NRATIVIDADECHK = :NRATIVIDADECHK";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getCriarVistoria($param)
    {
        $sql = "SELECT CDOPERADOR
                FROM FCM_GERENCIAMENTOCHK
                WHERE NRCHECKLISTAGEND = :NRCHECKLISTAGEND";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $param);
    }

    public function inserirEquipe($parametros)
    {
        $sql = "INSERT INTO FCM_EQUIPETAREFA(NREQUIPETAREFA, NREQUIPE, NRCHECKLISTAGEND, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                VALUES (:NREQUIPETAREFA, :NREQUIPE, :NRCHECKLISTAGEND, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function buscarOperadoresEquipe($parametros)
    {
        $sql = "SELECT CDOPERADOR   
                FROM FCM_RELACEQUIPEOPER
                WHERE NREQUIPE = :NREQUIPE";
        
        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getHistoricoTarefa($parametros)
    {
        $sql = "SELECT HIST.NRCHKAGENDHISTORICO, HIST.NRCHECKLISTAGEND, HIST.NMCHECKLISTAGEND, HIST.DSCHKAGENDHISTORICO, 
                TO_CHAR(HIST.DTCHKAGENDHISTORICO, 'DD/MM/YYYY HH24:MI') AS DTCHKAGENDHISTORICO, HIST.IDTIPOHISTORICO, HIST.DTINCLUSAO,
                TO_CHAR(HIST.DTULTATU, 'DD/MM/YYYY HH24:MI') AS DTULTATU, HIST.CDOPERULTATU, OPER.NMOPERADOR AS NMOPERULTATU
                FROM FCM_CHKAGENDHISTORICO HIST
                JOIN OPERADOR OPER ON OPER.CDOPERADOR = HIST.CDOPERULTATU
                WHERE HIST.NRCHECKLISTAGEND = :NRCHECKLISTAGEND
                ORDER BY HIST.DTCHKAGENDHISTORICO DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }
}
