<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Fm00011000AnaliseNaoConformidadesFactory
{
    use TQuery;
    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getNaoConformidadesGerais()
    {

        $sql = "SELECT CRIT.NRCRITERIOTAREFACHK, CRIT.NMCRITERIOTARGERCHK AS DSCRITERIOTAREFA, LOC.NRLOCALCLIENTE, LOC.NMLOCALCLIENTE, LOC.NRTIPOLOCALCLI, TP.NMTIPOLOCALCLI, OPER.CDOPERADOR, OPER.NMOPERADOR, 
                    OPPAI.NMOPERADOR AS NMOPERADORPAI, COUNT(CRIT.NRCRITERIOTAREFACHK) AS QTD, TO_CHAR(GECHK.DTHORAAGEND, 'DD/MM/YYYY') AS DTINCLUSAO, GECHK.NRCHECKLISTAGEND, CRIT.NRCRITERIOTARGERCHK
              FROM FCM_GERENCIAMENTOCHK GECHK
              JOIN FCM_TAREFAGERCHK TA
                ON GECHK.NRGERENCIAMENTOCHK = TA.NRGERENCIAMENTOCHK
              JOIN FCM_CRITERIOTARGERCHK CRIT
                ON CRIT.NRTAREFAGERCHK = TA.NRTAREFAGERCHK
              JOIN FCM_CHECKLISTAGEND CKAGND
                ON CKAGND.NRCHECKLISTAGEND = GECHK.NRCHECKLISTAGEND
              JOIN OPERADOR OPER
                ON OPER.CDOPERADOR = CKAGND.CDOPERADOR
              JOIN OPERADOR OPPAI
                ON OPPAI.CDOPERADOR = GECHK.CDOPERADOR
              JOIN FCM_LOCALCLI LOC
                ON LOC.NRLOCALCLIENTE = GECHK.NRLOCALCLIENTE
              JOIN FCM_TIPOLOCALCLI TP
                ON TP.NRTIPOLOCALCLI = LOC.NRTIPOLOCALCLI
              WHERE CRIT.IDMARCADO = 'S'
              GROUP BY CRIT.NRCRITERIOTAREFACHK, OPER.CDOPERADOR, GECHK.DTHORAAGEND, LOC.NRLOCALCLIENTE, 
                      OPER.NMOPERADOR, LOC.NMLOCALCLIENTE, OPPAI.NMOPERADOR, 
                      CRIT.NMCRITERIOTARGERCHK, GECHK.NRCHECKLISTAGEND,
                      LOC.NRTIPOLOCALCLI, TP.NMTIPOLOCALCLI, CRIT.NRCRITERIOTARGERCHK";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getPrincipaisNaoConformidades($filter)
    {

        $sql = "SELECT CTGC.NRCRITERIOTAREFACHK, CTGC.NMCRITERIOTARGERCHK, COUNT(CTGC.NRCRITERIOTAREFACHK) AS QTDADE
              FROM FCM_CRITERIOTARGERCHK CTGC
              JOIN FCM_TAREFAGERCHK TGC
                ON CTGC.NRTAREFAGERCHK = TGC.NRTAREFAGERCHK
                JOIN FCM_GERENCIAMENTOCHK GECHK
                ON GECHK.NRGERENCIAMENTOCHK = TGC.NRGERENCIAMENTOCHK
              WHERE IDMARCADO = 'S' " . $filter . "
          GROUP BY CTGC.NRCRITERIOTAREFACHK, CTGC.NRCRITERIOTAREFACHK, CTGC.NMCRITERIOTARGERCHK
          ORDER BY QTDADE DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getCriterioNaoConformidade($param)
    {
        $sql = "SELECT LC.NMLOCALCLIENTE || ' | ' || TLC.NMTIPOLOCALCLI AS NMLOCAL, CTAC.NMCRITERIOTARGERCHK
              FROM FCM_CRITERIOTARGERCHK CTAC
              JOIN FCM_TAREFAGERCHK TAC
                ON CTAC.NRTAREFAGERCHK = TAC.NRTAREFAGERCHK
              JOIN FCM_GERENCIAMENTOCHK GC
                ON TAC.NRGERENCIAMENTOCHK = GC.NRGERENCIAMENTOCHK
              JOIN FCM_LOCALCLI LC
                ON GC.NRLOCALCLIENTE = LC.NRLOCALCLIENTE
              JOIN FCM_TIPOLOCALCLI TLC
                ON LC.NRTIPOLOCALCLI = TLC.NRTIPOLOCALCLI
              JOIN FCM_CRITERIOTAREFACHK CTC  
                ON CTAC.NRCRITERIOTAREFACHK = CTC.NRCRITERIOTAREFACHK
              JOIN FCM_CRITERIOTAREFA CT
                ON CTC.NRCRITERIOTAREFA = CT.NRCRITERIOTAREFA
              WHERE CTAC.IDMARCADO = 'S' " . $param;

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getCriteriosNaoConformidades()
    {
        $sql = "SELECT DISTINCT NRCRITERIOTAREFACHK, NMCRITERIOTARGERCHK
                FROM FCM_CRITERIOTARGERCHK
                WHERE IDMARCADO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
