<?php

namespace FM\Service;

use FM\Factory\EPIsFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use FM\Service\FindService;

class EPIsService
{

    protected $EPIsFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;
    protected $FindService;

    public function __construct(EPIsFactory $EPIsFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager, FindService $FindService)
    {
        $this->EPIsFactory = $EPIsFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
        $this->connection = $entityManager->getConnection();
        $this->FindService = $FindService;
    }
    
    public function getEPIs()
    {
        return $this->EPIsFactory->getEPIs();
    }

    public function salvarEPI($params)
    {
        $this->connection->beginTransaction();
        try {
            $nrorg = $this->Environment->getNrOrg();
            $operador = $this->Environment->getCdOperador();
            foreach ($params as $row) {
                if ($row["NREPI"] == 0) {
                    $param = array(
                        "NREPI" => $this->newCode->getCodeByTableName("FCM_EPI", $nrorg, 1, 10, true),
                        "NMEPI" => $row["NMEPI"],
                        "IDATIVO" => 'S',
                        "NRORG" => $nrorg,
                        "NRORGINCLUSAO" => $nrorg,
                        "CDOPERINCLUSAO" => $operador
                    );

                    $this->EPIsFactory->inserirEpis($param);
                } else {
                    $param = array(
                        "NREPI" => $row["NREPI"],
                        "NMEPI" => $row["NMEPI"],
                        "CDOPERULTATU" => $operador,
                        "NRORGULTATU" => $nrorg
                    );

                    $this->EPIsFactory->atualizarEPI($param); 
                }
            }

            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
    
    public function excluirEPI($params)
    {
        $this->connection->beginTransaction();
        try {
            $this->EPIsFactory->excluirEPI($this->FindService->formatarArray($params["ROW"]));
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

}
