export BackupController {

    public montaGridConflito({ row }: any) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-conflito-datas');
        grid.datasource.data = [];
        const dadosFilho = this.conflitoDatas.filter((dados: any) => (dados.INDEXPAI === row.INDEX));
        dadosFilho.forEach((dados: any) => {
            grid.datasource.data.push({
                DHINICIALGRID: dados.DHINICIALGRID,
                DHFINALGRID: dados.DHFINALGRID,
                NRCHECKLISTAGEND: dados.NRCHECKLISTAGEND,
                NMCHECKLISTAGEND: dados.NMCHECKLISTAGEND,
                INDEX: dados.INDEX,
                INDEXPAI: dados.INDEXPAI,
            });
        });
        this.rowClickFiltroGrid();
    }


    public montaGrid() {
        const grid = Metadata.getInstance<TekTreeGrid>('tek-grid-nova-tarefa');
        const dadosPai = this.conflitoDatas.filter((dados: any) => (dados.INDEXPAI === null));
        dadosPai.forEach((dados: any) => {
            grid.datasource.data.push({
                DHINICIALNOVA: dados.DHINICIALNOVA,
                DHFINALNOVA: dados.DHFINALNOVA,
                NMOPERADOR: dados.NMOPERADOR,
                INDEX: dados.INDEX,
                INDEXPAI: dados.INDEXPAI,
                NRCHECKLISTAGEND: dados.NRCHECKLISTAGEND,
                CDOPERADOR: dados.CDOPERADOR,
                HORAINICIO: dados.HORAINICIO,
                acoesSelect: dados.acoesSelect,
            });
        });
    }

    public atualizaBancoConflitos(dadosEditados: any) {
        dadosEditados.forEach((element: any) => {
            const dataInicio = Utilities.creatDate(element.DHINICIALNOVA);
            const din = new Date(dataInicio.valueOf());
            const [hora, minuto] = element.HORAINICIO.split(':');
            din.setHours(hora);
            din.setMinutes(minuto);
            const pos = this.bancoConflito.findIndex((dados: any) => dados.INDEX === element.INDEX);
            this.bancoConflito[pos].FUNCIONARIO = (element.NMOPERADOR.length === 12) ? element.NMOPERADOR : element.CDOPERADOR;
            this.bancoConflito[pos].DATAINICIAL = `${din.toLocaleDateString('en-us')} ${(`00${din.getHours()}`).slice(-2)}:${(`00${din.getMinutes()}`).slice(-2)}`;
            this.bancoConflito[pos].IGNORAR = element.acoesSelect;
            this.bancoConflito[pos].DATAFINAL = `${din.toLocaleDateString('en-us')} ${(`00${din.getHours()}`).slice(-2)}:${(`0000${String(this.bancoConflito[pos].DURACAO)}`).slice(-2)}`;
        });
    }

    public conflitosHoraGrid: any = [];

    public verificaConflitosGrid(Operador: any, HORAINICIO: any, HORAFINAL: any, index: any, tarefa: any) {
        this.baseDadosGrid.forEach((element: any) => {
            const HI = element.HORAINICIO;
            const HF = element.HORAFINAL;
            if (element.OPERADOR === Operador && element.index !== index) {
                if ((HORAINICIO >= HI && HORAINICIO <= HF) || (HORAFINAL >= HI && HORAFINAL <= HF)) {
                    this.conflitosHoraGrid.push({
                        INDEX: index,
                        OPERADOR: element.OPERADOR,
                        TAREFA: tarefa,
                        CONFLITO: element.TAREFA,
                    });
                }
            }
        });
    }
    
        // Pega as informações do form como data inicial, duração e funcionário. Formata para ser compatível com a data do Grid vinda do backEnd.
        public formatarDataHora(editedRow: any, revalidar: boolean) {
            const periodo = Metadata.getInstance<DateRange>('select-periodo').value;
            const dataUnica = Metadata.getInstance<DateRange>('select-data').value;
    
            if (this.conflitosHoraGrid.length !== 0) {
                Utilities.alertMessage('Existem conflitos pendentes!', 'error');
            } else if (this.validaInsercao()) {
                let index = 1;
                const dataRange = (periodo.length === 0) ? dataUnica : periodo;
                const dataFormatada = this.formataData(dataRange);
                // const diasSemana = Metadata.getInstance<Select>('selectDiaSemana').value;
    
                if (revalidar) {
                    // const grid = Metadata.getInstance<TekTreeGrid>('tek-grid-nova-tarefa');
                    const HORAINICIO = 0;
    
                    editedRow.forEach((iteracoes: any) => {
                        const din = Utilities.creatDate(iteracoes.DHINICIALNOVA);
                        let dfn = Utilities.creatDate(iteracoes.DHFINALNOVA);
                        const CDOPERADOR = (iteracoes.NMOPERADOR.length === 12) ? iteracoes.NMOPERADOR : iteracoes.CDOPERADOR;
                        const duracao = ((dfn.valueOf() - din.valueOf()) / 1000 / 60);
                        const [hora, minuto] = iteracoes.HORAINICIO.split(':');
                        din.setHours(hora);
                        din.setMinutes(minuto);
                        dfn = new Date(din.valueOf());
                        dfn.setMinutes(dfn.getMinutes() + duracao);
                        this.validaHorario(din, dfn, CDOPERADOR, iteracoes.encarregado, iteracoes.INDEX, HORAINICIO);
                        this.fecharModalConflitoDatas();
                        // this.montaGrid();
                    });
                } else {
                    this.conflitoDatas = [];
                    this.bancoConflito = [];
                    this.executorHora().forEach((element: any) => {
                        const dataInicio = new Date(dataFormatada[0].valueOf());
                        for (dataInicio; dataInicio <= dataFormatada[1]; dataInicio.setDate(dataInicio.getDate() + 1)) {
                            // if (diasSemana.includes(String(dataInicio.getDay()))) {
                            const din = new Date(dataInicio.valueOf());
                            const [hora, minuto] = element.HORAINICIO.split(':');
                            const { HORAINICIO } = element;
                            din.setHours(hora);
                            din.setMinutes(minuto);
                            const dfn = new Date(din.valueOf());
                            dfn.setMinutes(dfn.getMinutes() + (Math.trunc(element.DURACAO / 100) * 60) + (element.DURACAO % 100));
                            this.copy = JSON.parse(JSON.stringify(element));
                            this.copy.INDEX = index;
                            this.copy.DURACAO = ((dfn.valueOf() - din.valueOf()) / 1000 / 60);
                            this.copy.DATAFINAL = `${dfn.toLocaleDateString('en-us')} ${(`00${dfn.getHours()}`).slice(-2)}:${(`00${dfn.getMinutes()}`).slice(-2)}`;
                            this.copy.DATAINICIAL = `${din.toLocaleDateString('en-us')} ${(`00${din.getHours()}`).slice(-2)}:${(`00${din.getMinutes()}`).slice(-2)}`;
                            this.copy.NRSEQCONTRATO = element.NRSEQCONTRATO;
                            this.bancoConflito.push(this.copy);
    
                            if (this.parametrizacao === 'N') {
                                this.validaHorario(din, dfn, element.FUNCIONARIO, element.ENCARREGADO, index, String(HORAINICIO));
                            }
                            index += 1;
                            // }
                        }
                    });
                }
    
                this.title = Metadata.getInstance<TextInput>('nomeTarefa').value;
                if (this.conflitoDatas.length > 0) {
                    this.exibirModalConflitoDatas();
                } else {
                    // this.fecharModalTarefasMassa();
                    this.inserirTarefa();
                }
            }
        }
    
        public verificarConflitos({ component }: IEventParam<TekGrid>) {
            if (Utilities.validateGrid(component)) {
                this.atualizaBancoConflitos(component.getEditedRows());
                const alteracoes: any = component.getEditedRows().filter((elemento: any) => elemento.acoesSelect !== 1);
                const revalidar = true;
                this.conflitoDatas = [];
                this.formatarDataHora(alteracoes, revalidar);
            }
        }
    
        public confirmaInsercao() {
            if (this.conflitoDatas.length > 0) {
                Utilities.alertMessage('Existem conflitos pendentes!', 'error');
            } else {
                this.fecharModalConflitoDatas();
                // this.fecharModalTarefasMassa();
                this.inserirTarefa();
            }
        }


    // Recebe um intervalo de data/hora para ser comaprado com o grid afim de validar se há valores iguais.
    // dig == data inicial grid. dfg == data final grid
    // din == data inicial nova. dfn == data final nova
    public validaHorario(din: any, dfn: any, funcionario: any, encarregado: any, index: any, horaInicio: any) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas').datasource.data;
        grid.forEach((element: any) => {
            const dig = Utilities.creatDate(element.DTHORAAGEND);
            const dfg = Utilities.creatDate(element.DTHRFINALAGEND);
            if (funcionario === element.CDOPERADOR) {
                if (((din.valueOf() >= dig.valueOf() && din.valueOf() <= dfg.valueOf()) || (dfn.valueOf() >= dig.valueOf() && dfn.valueOf() <= dfg.valueOf()))
                || (dig.valueOf() >= din.valueOf() && dig.valueOf() <= dfn.valueOf()) || (dig.valueOf() >= din.valueOf() && dig.valueOf() <= dfn.valueOf())) {
                    const teste = this.conflitoDatas.findIndex((elemento: any) => elemento.INDEX === index);
                    if (teste < 0) {
                        this.conflitoDatas.push({
                            INDEX: index,
                            DHINICIALNOVA: `${din.toLocaleDateString('en-us')} ${(`00${din.getHours()}`).slice(-2)}:${(`00${din.getMinutes()}`).slice(-2)}`,
                            DHFINALNOVA: `${dfn.toLocaleDateString('en-us')} ${(`00${dfn.getHours()}`).slice(-2)}:${(`00${dfn.getMinutes()}`).slice(-2)}`,
                            INDEXPAI: null,
                            NMOPERADOR: element.NMOPERADOR,
                            CDOPERADOR: element.CDOPERADOR,
                            ENCARREGADO: encarregado,
                            HORAINICIO: horaInicio,
                            acoesSelect: 'Não',
                        });
                    }
                    this.conflitoDatas.push({
                        DHINICIALGRID: `${dig.toLocaleDateString('en-us')} ${(`00${dig.getHours()}`).slice(-2)}:${(`00${dig.getMinutes()}`).slice(-2)}`,
                        DHFINALGRID: `${dfg.toLocaleDateString('en-us')} ${(`00${dfg.getHours()}`).slice(-2)}:${(`00${dfg.getMinutes()}`).slice(-2)}`,
                        INDEX: `${index}${this.conflitoDatas.length}`,
                        INDEXPAI: index,
                        NRCHECKLISTAGEND: element.NRCHECKLISTAGEND,
                        NMCHECKLISTAGEND: element.NMCHECKLISTAGEND,
                    });
                }
            }
        });
    }

    public async exibirModalConflitoDatas() {
        if (this.modalConflitoDatas) {
            await this.fecharModalConflitoDatas();
        }
        this.modalConflitoDatas = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00004_000_tarefas/modal/fm_00004_004_modal_conflito_datas' });
        this.modalConflitoDatas.show();
    }

    public async fecharModalConflitoDatas() {
        this.modalConflitoDatas.hide();
        this.modalConflitoDatas?.destroy();
        this.visibilidadeGridItens = false;
        this.visibilidadeForm = true;
    }

    public pegaInformacoesGrid({ component }: any) {
        // const DATARANGE = this.formataData(Metadata.getInstance<DateRange>('selectData'));
        if (component.isGridValid(component)) {
            const BASEDADOS = component.getEditedRows();
            let index = 0;
            this.baseDadosGrid = [];
            BASEDADOS.forEach((element: any) => {
                let [hora, minuto] = element.HORAINICIO.split(':');
                const horaduracao = Number(element.DURACAO.slice(0, 2));
                const minutoduracao = Number(element.DURACAO.slice(2, 4));
                hora = Number(hora);
                minuto = Number(minuto);
                this.baseDadosGrid.push({
                    HORAINICIO: (hora * 60) + minuto,
                    HORAFINAL: (hora * 60) + minuto + (horaduracao * 60) + minutoduracao,
                    OPERADOR: element.OPERADOR,
                    TAREFA: element.NMLOCALCLIENTE,
                    INDEX: index += 1,
                });
            });
            this.conflitosHoraGrid = [];
            if (this.parametrizacao === 'N') {
                this.baseDadosGrid.forEach((element: any) => {
                    this.verificaConflitosGrid(element.OPERADOR, element.HORAINICIO, element.HORAFINAL, element.INDEX, element.TAREFA);
                });
            }
            if (this.conflitosHoraGrid.length !== 0) {
                const nomesDasTarefasComConflito = (this.conflitosHoraGrid.map((elemento: any) => elemento.TAREFA).join(', '));
                DialogService.show({
                    name: 'basic-dialog',
                    title: 'Conflitos',
                    text: `Existem conflitos de horários nos seguintes locais: <br><br>${nomesDasTarefasComConflito}`,
                });
            }
        }
    }
}