import {
    IDictionary, Http, Metadata, IEventParam, Loader, SimpleDatasource,
    MemoryDatasource,
} from '@zeedhi/core';
import {
    Text, Textarea, Col, CheckboxMultiple, Form, FileInput, Modal, ModalService, LoadingService, Select, SelectMultiple, Date, Time, TextInput,
    IterableComponentRender, DialogService, Date as Data,
    DateRange,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';
import { IterableCarousel, TekGrid, TekTreeGrid } from '@zeedhi/teknisa-components-common';
import FileUpload from '../FileUpload';

export class Fm00005000VistoriasController {
    public hierarquiasController = Loader.getInstance('HierarquiasController');

    public visibilidadeFrameDetalhes = false;

    public visibilidadeTelaPrincipal = true;

    public visibilidade: boolean = true;

    public currentRow: any = {};

    public nomeVistoria: String = '';

    public nrfoto: String = '';

    private modalVisualizar!: Modal;

    private modalAnexo!: Modal;

    private modalInfoDetalhes!: Modal;

    private modalExibirImagens!: Modal;

    private modalAdicionarVistoria!: Modal;

    private modalEscolhaAcao!: Modal;

    private modalHistoricoVistoria!: Modal;

    public modalPreencherInformacoes!: Modal;

    public NRGERENCIAMENTOCHK: any = '';

    public modalAnexarImagem!: Modal;

    public disableCheckbox = false;

    public readonlyObservacao = false;

    public disableVistoria = false;

    public disableSalvarVistoria = false;

    public disableAnexarFoto = false;

    public disableExcluirFoto = false;

    public icone: string = 'mdi-play-pause';

    public visibilidadeFrameCarrouselImagens = true;

    public visibilidadeFrameAdicionarImagem = false;

    private parametrizacoes: any[] = [];

    public disabledPeriodo: boolean = false;

    public modConflito: boolean = false;

    public editedRows: any = '';

    public disabledPreencher: boolean = true;

    // Controle dos modais e visibilidade
    public async modalVisualizarDados({ row }: any) {
        this.modalVisualizar = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_001_vistorias_detalhes', true);
        this.modalVisualizar.show();
        this.currentRow = row;

        this.bloquearAcoesVistoriaAvaliada();
    }

    public async fecharModalVisualizarDados() {
        await this.modalVisualizar.hide();
        this.modalVisualizar.destroy();
    }

    public async abrirModalAnexo() {
        this.modalAnexo = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_002_modal_abrir_anexo', true);
        this.modalAnexo.show();
    }

    public async abrirModalPreencherMassa() {
        this.modalPreencherInformacoes = await ModalService.createFromJson('fm_00005_000_vistorias/modal/fm_00005_005_preencher_massa', true);
        this.modalPreencherInformacoes.show();
    }

    public async fecharModalPreencherMassa() {
        this.modalPreencherInformacoes.hide();
        this.modalPreencherInformacoes.destroy();
    }

    public async fecharModalAnexo() {
        await this.modalAnexo.hide();
        this.modalAnexo.destroy();
    }

    public async abrirModalExibirImagens() {
        this.modalExibirImagens = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_004_exibir_imagens_anexo', true);
        this.modalExibirImagens.show();
    }

    public async fecharModalExibirImagens() {
        await this.modalExibirImagens.hide();
        this.modalExibirImagens.destroy();
    }

    public async abrirModalInfoDetalhes() {
        this.modalInfoDetalhes = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_003_exibir_info_detalhes', true);
        this.modalInfoDetalhes.show();
    }

    public async fecharModalInfoDetalhes() {
        await this.modalInfoDetalhes.hide();
        this.modalInfoDetalhes.destroy();
    }

    public async abrirModalAdicionarVistoria() {
        this.modalAdicionarVistoria?.destroy();
        this.modalAdicionarVistoria = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_004_adicionar_vistorias', true);
        this.modalAdicionarVistoria.show();
    }

    public fecharModalAdicionarVistoria() {
        this.modalAdicionarVistoria.hide();
        this.modalAdicionarVistoria.destroy();
    }

    public async abrirModalEscolhaAcao() {
        this.modalEscolhaAcao?.destroy();
        this.modalEscolhaAcao = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_004_escolha_acao', true);
        this.modalEscolhaAcao.show();
    }

    public fecharModalEscolhaAcao() {
        this.modalEscolhaAcao.hide();
        this.modalEscolhaAcao.destroy();
    }

    public async abrirModalHistoricoVistoria() {
        this.modalHistoricoVistoria?.destroy();
        this.modalHistoricoVistoria = await ModalService.createFromJson('/fm_00005_000_vistorias/modal/fm_00005_005_historico_vistoria', true);
        this.modalHistoricoVistoria.show();
    }

    public fecharModalHistoricoVistoria() {
        this.modalHistoricoVistoria.hide();
        this.modalHistoricoVistoria.destroy();
    }

    public async ativaAbrirModalHistoricoVistoria() {
        await this.abrirModalHistoricoVistoria();
        Metadata.getInstance<TekGrid>('grid-historico-vistoria').datasource.setFilter({
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK,
        });
    }

    public setCurrentRow({ row }: any) {
        this.currentRow = row;
    }

    public invisivel({ component }: any) {
        component.isVisible = false;
    }

    public visualizarDadosGerais({ row }: any) {
        this.visibilidade = false;
        this.currentRow = row;
        this.NRGERENCIAMENTOCHK = row.NRGERENCIAMENTOCHK;
    }

    public exibirImagem({ component }: any) {
        const carrosel = Metadata.getInstance<IterableCarousel>(component.name.split('_')[1]);
        carrosel.iterable.datasource.updateData([]);
        const row = Metadata.getInstance<Col>('LinhaCarrosel');
        const imagens: any = [];
        if (component.value.length) {
            row.isVisible = true;
            component.value.forEach((imagem: any, pos: number) => {
                imagens.push({
                    id: `cliente_${pos}`,
                    src: window.URL.createObjectURL(imagem),
                });
            });
        } else {
            row.isVisible = false;
        }
        carrosel.iterable.datasource.updateData(imagens);
    }

    // ---------- Validações e filtros ----------
    public setFiltroModal({ component }: IEventParam<TekTreeGrid>) {
        component.datasource.setFilter({
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK,
        });
    }

    public tituloPagina({ component }: any) {
        const tituloModal = this.currentRow.NMGERENCIAMENTOCHK;
        component.text = tituloModal;
    }

    /* eslint-disable */
    public linhaEditavel({ row }: IDictionary<any>) {
        return (row.TIPO !== 'Critério') ? false : true;
    }
    
    public mudaCor({ row }: IDictionary<any>) {
        if (row.IDMARCADO === 'N') {
            return { 'color': 'rgb(255, 0, 0)' };
        }
        return {};
    }
    /* eslint-enable */

    public validaObservacoes({ component }: any) {
        if (this.currentRow.IDOBRIGAOBSERVACAO !== 'S') {
            component.clearValidations();
        }
    }

    public setFiltro({ component }: any) {
        component.datasource.dynamicFilter = {
            IDATIVO: [{
                relation: 'AND',
                operation: 'IN',
                value: 'S',
            }],
        };
        component.datasource.get();
    }

    // ---------- Requisições de get e post ----------
    public salvarCriterios() {
        LoadingService.show();
        const arrayObs: IDictionary = [];
        const iterableCards = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades');

        iterableCards.datasource.data.forEach((cat: any) => {
            const checkboxAtividades = Metadata.getInstance<CheckboxMultiple>(`checkbox-multiple_${cat.NRATIVIDADECHK}`);
            const criterios = checkboxAtividades.value;
            if (criterios !== null && criterios !== undefined) {
                arrayObs.push({
                    CRITERIOS: criterios,
                    NRATIVIDADECHK: cat.NRATIVIDADECHK,
                    NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK.toString(),
                });
            }
        });

        Http.post('/salvarCriterios', {
            ARRAYOBS: arrayObs,
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK.toString(),
            NMGERENCIAMENTOCHK: this.currentRow.NMGERENCIAMENTOCHK.toString(),
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        });

        this.salvarObservacao();
    }

    public salvarObservacao() {
        const iterableCards = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades');
        const tekGrid = Metadata.getInstance<TekGrid>('tek-grid-vistorias');

        Http.post('/salvarObservacao', {
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK.toString(),
            DSOBSTAREFAGERCHK: Metadata.getInstance<Textarea>('text-area-observation').value,
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            iterableCards.datasource.get();
            tekGrid.datasource.get();
            LoadingService.hide();
        });
    }

    public carregarFotos({ component }: any) {
        component.iterable.datasource.setFilter({
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK,
        });
    }

    public carregarFotosTarefa({ component }: any) {
        const nr = this.currentRow.NRCHECKLISTAGEND;

        LoadingService.show();
        Http.post('/getFotosTarefas', {
            NRCHECKLISTAGEND: nr,
        }).then((response: any) => {
            if (response.data.data.length === 0) {
                component.isVisible = false;
                Metadata.getInstance<Text>('sem-resultado-imagens-tarefas').isVisible = true;
            } else {
                response.data.data.forEach((dados: IDictionary) => {
                    component.iterable.datasource.data.push({
                        NRFOTOTAREFAAGEND: dados.NRFOTOTAREFAAGEND,
                        DSFOTOTAREFAAGEND: dados.DSFOTOTAREFAAGEND,
                    });
                });
            }
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    // Seta as informações no modal Info Detelhes
    public montarInformacoesComplementares() {
        LoadingService.show();
        const nr = this.currentRow.NRCHECKLISTAGEND;
        const checkbox = Metadata.getInstance<CheckboxMultiple>('checkbox-itens');
        const observacoes = Metadata.getInstance<Textarea>('observacoes-tarefas');
        const semItens = Metadata.getInstance<Text>('nao-ha-itens');
        let mensagem = '';

        Http.post('/getItensTarefas', {
            NRCHECKLISTAGEND: nr,
        }).then((response: IDictionary) => {
            const dados = response.data.data;

            checkbox.value = dados.filter((elemento: any) => elemento.IDREALIZADO === 'S').map((elemento: any) => elemento.NMTAREFA);
            (checkbox.datasource as SimpleDatasource)!.items = dados.map((elemento: any) => elemento.NMTAREFA);

            if (dados.length > 0) {
                semItens.isVisible = false;
            } else {
                semItens.isVisible = true;
            }

            if (this.currentRow.DSJUSTCANCELAMENTO !== null && dados.DSOBSTAREFAAGEND !== undefined) {
                mensagem = `Justificativa de cancelamento: ${this.currentRow.DSJUSTCANCELAMENTO} - Observações da Tarefa: ${dados.DSOBSTAREFAAGEND}`;
            } else if (this.currentRow.DSJUSTCANCELAMENTO !== null) {
                mensagem = `Justificativa de cancelamento: ${this.currentRow.DSJUSTCANCELAMENTO}`;
            } else if (dados.DSOBSTAREFAAGEND !== undefined) {
                mensagem = `Observações da Tarefa: ${dados.DSOBSTAREFAAGEND}`;
            } else {
                mensagem = 'Não há observações';
            }
            observacoes.value = mensagem;
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public montarObservacao() {
        const nr = this.currentRow.NRGERENCIAMENTOCHK;
        const { data } = Metadata.getInstance<IterableComponentRender>('tek-grid-vistorias').datasource;
        const observacoes = Metadata.getInstance<Textarea>('text-area-observation');
        const dados: any = data.find((row: any) => row.NRGERENCIAMENTOCHK === Number(nr));

        if (this.currentRow.IDOBRIGAOBSERVACAO !== 'S') {
            observacoes.clearValidations();
        }

        Metadata.getInstance<Textarea>('text-area-observation').value = (dados.OBS !== null) ? dados.OBS.replaceAll('_', '\n') : '';
    }

    public async anexarImage() {
        const imagensConvertidas = await FileUpload.converterImagens('FileInput-ImagensDoAtivo_carouselImagesAnexoTask');
        const carrousel = Metadata.getInstance<IterableCarousel>('carousel-imagens-anexo-vistorias');
        const carrouselAnexar = Metadata.getInstance<IterableCarousel>('carouselImagesAnexoTask');
        if (imagensConvertidas.length > 0) {
            LoadingService.show();
            Http.post('/anexarFotoVistoria', {
                IMAGEM: imagensConvertidas,
                NRTAREFA: this.currentRow.NRGERENCIAMENTOCHK,
            }).then((response: any) => {
                carrousel.iterable.datasource.get();

                if (response.data === 'success') {
                    const file = Metadata.getInstance<FileInput>('FileInput-ImagensDoAtivo_carouselImagesAnexoTask');
                    file.value = [];
                    Utilities.messages('OK', 'Imagens anexadas com sucesso!');
                    this.fecharFrameAdicionarImagens();
                    carrouselAnexar.iterable.datasource.updateData([]);
                } else {
                    Utilities.messages('Error', 'Ocorreu um erro ao salvar as imagens.<br>.Tente novamente.<br><br>Se o problema persistir entre em contato com o suporte.');
                }
            })
            .finally(() => {
                LoadingService.hide();
            });
        }
    }

    public deletImage({ component }: any) {
        DialogService.show({
            name: 'deletar-image-confirmacao',
            title: 'Excluir',
            text: 'Deseja realmente apagar essa foto?',
            buttons: [
                {
                    name: 'no',
                    component: 'ZdButton',
                    label: 'Nao',
                    outline: true,
                    events: {
                        click: () => {
                            DialogService.hide();
                        },
                    },
                },
                {
                    name: 'yes',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            this.excluirImagem(component);
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public excluirImagem(parametro: any) {
        LoadingService.show();
        const carrosel = Metadata.getInstance<IterableCarousel>('carousel-imagens-anexo-vistorias');

        Http.post('/excluirImagensVistoria', {
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK,
            NRFOTOTAREFAGERCHK: parametro.name.split('_')[1],
        }).then(() => {
            carrosel.iterable.datasource.get();
        })
        .catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public abrirFrameAdicionarImagens() {
        this.visibilidadeFrameCarrouselImagens = false;
        this.visibilidadeFrameAdicionarImagem = true;
    }

    public fecharFrameAdicionarImagens() {
        this.visibilidadeFrameCarrouselImagens = true;
        this.visibilidadeFrameAdicionarImagem = false;
    }

    public bloquearAcoesVistoriaAvaliada() {
        const situacao = this.currentRow.IDSITUACAOGERCHK.toString();

        if (situacao === 'Avaliado' || situacao === 'Tarefa Pendente' || situacao === 'Em andamento (Tarefa em correção)') {
            this.disableCheckbox = true;
            this.disableVistoria = true;
            this.readonlyObservacao = true;
            this.disableSalvarVistoria = true;
            this.disableAnexarFoto = true;
            this.disableExcluirFoto = true;
        } else {
            this.disableCheckbox = false;
            this.disableVistoria = false;
            this.readonlyObservacao = false;
            this.disableSalvarVistoria = false;
            this.disableAnexarFoto = false;
            this.disableExcluirFoto = false;
        }
    }

    public montarCriterios({ component }: any) {
        Http.post('/getCriterios', {
            NRATIVIDADECHK: component.name.split('_')[1],
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK.toString(),
        }).then((response: IDictionary) => {
            if (component.datasource instanceof SimpleDatasource) {
                component!.datasource!.items = response.data.map((elemento: any) => elemento.NMCRITERIOTARGERCHK);
                component.value = response.data.filter((elemento: any) => elemento.IDMARCADO === 'S').map((elemento: any) => elemento.NMCRITERIOTARGERCHK);
            }
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public async verificaNaoConformidades() {
        const { data } = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades').datasource;
        const atividades = data.map((elemento: any) => elemento.NRATIVIDADECHK);
        const form = Metadata.getInstance<Form>('form-observacoes');
        let cont = 0;

        atividades.forEach((nr: any) => {
            const criterio = Metadata.getInstance<CheckboxMultiple>(`checkbox-multiple_${nr}`);

            if (criterio.value.length > 0) {
                /* eslint-disable */
                cont++;
                /* eslint-enable */
            }
        });

        if (cont > 0 && Utilities.validateForm(form) && this.currentRow.NRCHECKLISTAGEND !== null) {
            const paramIDNaoConformidade = this.parametrizacoes[0].IDNAOCONFORMVIST;

            if (paramIDNaoConformidade === '3' || paramIDNaoConformidade === null) {
                this.abrirModalEscolhaAcao();
            } else if (paramIDNaoConformidade === '2') {
                this.finalizarVistoria();
            } else if (paramIDNaoConformidade === '1') {
                this.voltarTarefa();
            }
        } else {
            this.finalizarVistoria();
        }
    }

    public voltarTarefa() {
        const { data } = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades').datasource;
        const atividades = data.map((elemento: any) => elemento.NRATIVIDADECHK);
        const atividadesNaoConform: any[] = [];

        atividades.forEach((nr: any) => {
            const criterio = Metadata.getInstance<CheckboxMultiple>(`checkbox-multiple_${nr}`);

            if (criterio.value.length > 0 && !atividadesNaoConform.includes(nr)) {
                atividadesNaoConform.push(nr);
            }
        });

        LoadingService.show();
        Http.post('/voltarTarefa', {
            NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK,
            NMGERENCIAMENTOCHK: this.currentRow.NMGERENCIAMENTOCHK,
            NRCHECKLISTAGEND: this.currentRow.NRCHECKLISTAGEND,
            ATIVIDADES: atividadesNaoConform,
        }).then(() => {
            Utilities.showSuccessMessage();
            this.fecharModalVisualizarDados();
            if (this.modalEscolhaAcao) {
                this.fecharModalEscolhaAcao();
            }
            Metadata.getInstance<TekGrid>('tek-grid-vistorias').datasource.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public finalizarVistoria() {
        const form = Metadata.getInstance<Form>('form-observacoes');
        const iterableVistorias = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades');
        const tekGridVistorias = Metadata.getInstance<TekGrid>('tek-grid-vistorias');
        const { data } = Metadata.getInstance<IterableComponentRender>('card-iterable-atividades').datasource;
        const atividades = data.map((elemento: any) => elemento.NRATIVIDADECHK);
        const textArea = Metadata.getInstance<Textarea>('text-area-observation');
        let contador = 0;
        let obs = '';

        atividades.forEach((nr: any) => {
            const criterio = Metadata.getInstance<CheckboxMultiple>(`checkbox-multiple_${nr}`).value;

            if (criterio.length > 0) {
                contador += 1;
                obs = textArea.value;
            } else if (contador === 0) {
                obs = (textArea.value) ? `${textArea.value}__Mensagem automática: Vistoria finalizada sem critérios de não conformidade` : 'Mensagem automática: Vistoria finalizada sem critérios de não conformidade';
            }
        });

        if (Utilities.validateForm(form)) {
            LoadingService.show();
            Http.post('/finalizarVistoria', {
                NRGERENCIAMENTOCHK: this.currentRow.NRGERENCIAMENTOCHK.toString(),
                NMGERENCIAMENTOCHK: this.currentRow.NMGERENCIAMENTOCHK.toString(),
                NRCHECKLISTAGEND: this.currentRow.NRCHECKLISTAGEND,
                DSOBSTAREFAGERCHK: obs,
                ATIVIDADES: atividades,
                POSSUINAOCONFORM: contador > 0,
            }).then(() => {
                Utilities.showSuccessMessage();
                iterableVistorias.datasource.get();
                tekGridVistorias.datasource.get();
                this.fecharModalVisualizarDados();
                if (this.modalEscolhaAcao) {
                    this.fecharModalEscolhaAcao();
                }
                Metadata.getInstance<TekGrid>('tek-grid-vistorias').datasource.get();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
                LoadingService.hide();
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public changeTipoDeLocal({ component }: IEventParam<Select>) {
        const tipoLocal = Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI');
        const local = Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');

        tipoLocal.value = null;
        local.value = null;
        checklist.value = null;
        if (component.value) {
            tipoLocal.disabled = false;
            tipoLocal.datasource.setFilter({
                CDCLIENTE: component.value,
            });
        } else {
            tipoLocal.disabled = true;
            local.disabled = true;
        }
    }

    public excluirVistorias({ event }: any) {
        const component = Metadata.getInstance<TekGrid>('tek-grid-vistorias');
        let canDelete = true;
        const selected = component.selectedRows.map((element: any) => ({ IDSITUACAOGERCHK: element.IDSITUACAOGERCHK, NRCHECKLISTAGEND: element.NRCHECKLISTAGEND }));
        selected.forEach((element: any) => {
            if (element.IDSITUACAOGERCHK === 'Tarefa Pendente' || element.NRCHECKLISTAGEND !== null) {
                DialogService.show({
                    name: 'error',
                    type: 'error',
                    title: 'Erro ao excluir Vistoria',
                    text: 'Impossivel excluir vistoria com Tarefa Pendente ou relacionada a alguma Tarefa',
                });
                canDelete = false;
            }
        });
        if (canDelete) {
            Utilities.showConfirmDeleteMessage(event, 'Fm00005000VistoriasController.deleteVistorias', 'Excluir Registro?');
        }
    }

    public deleteVistorias() {
        const component = Metadata.getInstance<TekGrid>('tek-grid-vistorias');
        LoadingService.show();
        Http.post('/deleteVistorias', {
            ROWS: component.selectedRows.map((element: any) => ({ NRGERENCIAMENTOCHK: element.NRGERENCIAMENTOCHK, NRTAREFAGERCHK: element.NRTAREFAGERCHK })),
        }).then(() => {
            component.datasource.get();
            Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            component.selectedRows = [];
            LoadingService.hide();
            DialogService.hide();
        });
    }

    public changeLocal({ component }: IEventParam<SelectMultiple>) {
        const local = Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');

        if (component.value.length > 0) {
            local.disabled = false;
            checklist.disabled = false;

            local.datasource.setFilter({
                NRTIPOLOCALCLI: component.value,
                UNICA: 'N',
                CDCLIENTE: Metadata.getInstance<Select>('CDCLIENTE').value,
            });

            checklist.datasource.setFilter({
                NRTIPOLOCALCLI: component.value,
                UNICA: 'N',
            });
        } else {
            local.value = null;
            checklist.value = null;
            local.disabled = true;
            checklist.disabled = true;
        }
    }

    /* INTEGRAÇÃO COM SM */
    public async changeContratos({ component }: any) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');
        if (grid.editing) {
            await Metadata.getInstance<Select>(component.name).datasource.setFilter({
                NRESTRUTURAM: grid.datasource.currentRow.NRESTRUTURAM,
            });
            grid.columns[1].setLookupDataFilter({ NRESTRUTURAM: grid.datasource.currentRow.NRESTRUTURAM });
            this.focusContratos({ component });
        }
    }

    public focusContratos({ component }: IEventParam<Select>) {
        if (component.datasource.data.length > 0) {
            // component.addValidation('required', {});
        } else {
            component.removeValidation('required');
        }
    }

    /* INTEGRAÇÃO COM SM */

    public changeItensChecklist({ component }: IEventParam<Select>) {
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK');
        if (component.value) {
            itenschecklist.disabled = false;
            itenschecklist.datasource.setFilter({
                NRCHECKLIST: component.value,
            });
        } else {
            itenschecklist.value = null;
            itenschecklist.disabled = true;
        }
    }

    public changeEscopo({ component }: IEventParam<SelectMultiple>) {
        const escopo = Metadata.getInstance<Select>('NRESCOPOSTAREFA');
        if (component.value) {
            escopo.disabled = false;
        } else {
            escopo.value = null;
            escopo.disabled = true;
        }
    }

    public changeTarefa({ component }: IEventParam<SelectMultiple>) {
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');

        if (component.value) {
            tarefa.disabled = false;
            tarefa.datasource.setFilter({
                NRATIVIDADECHK: itenschecklist.value,
            });
        } else {
            tarefa.value = null;
            tarefa.disabled = true;
        }
    }

    public get itensCheckList(): object {
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        return itenschecklist.value;
    }

    public get itensCheckListRow(): object {
        const itenschecklist = Metadata.getInstance<Select>('informacoesItensChecklist');
        return itenschecklist.value;
    }

    public setCriterios({ component }: IEventParam<SelectMultiple>) {
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const gridCriterios = Metadata.getInstance<TekGrid>('tek-grid-criterios-de-avaliacao-cadastro');

        if (component.value.length !== 0) {
            gridCriterios.datasource?.setFilter({
                NRTAREFACHK: component.value,
                NRATIVIDADECHK: itenschecklist.value,
                NRCHECKLIST: checklist.value,
            });
            gridCriterios.datasource?.get();
            gridCriterios.isVisible = true;
        } else {
            gridCriterios.datasource.updateData([]);
        }
    }

    // Tarefas em massa Controller
    public inserirVistoria() {
        const formVistorias = Metadata.getInstance<Form>('form-cadastro-vistorias');
        const formCriterios = Metadata.getInstance<Form>('formTarefas_dropBox-criterio-avaliacao');
        const formAgendamento = Metadata.getInstance<Form>('formTarefas_dropBoxDadosAgendamento');
        const tekGridCriteriosDeAvaliacaoCadastro = Metadata.getInstance<TekGrid>('tek-grid-criterios-de-avaliacao-cadastro');
        const diaSemana = Metadata.getInstance<SelectMultiple>('selectDiaSemana').value;
        const dataRange = Metadata.getInstance<DateRange>('select-periodo').value;
        const data = Metadata.getInstance<DateRange>('select-data').value;
        const grid = Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');

        if (grid.isGridValid(true)) {
            if (Utilities.validateForm(formVistorias) && Utilities.validateForm(formCriterios) && Utilities.validateForm(formAgendamento)) {
                const parametros = {
                    NOMETAREFA: Metadata.getInstance<TextInput>('nome-vistorias').value,
                    CDCLIENTE: Metadata.getInstance<Select>('CDCLIENTE').value,
                    NRTIPOLOCALCLI: Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI').value,
                    NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').value,
                    NRCHECKLIST: Metadata.getInstance<Select>('NRCHECKLIST').value,
                    NRATIVIDADECHK: Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK').value,
                    NRESCOPOSTAREFA: Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA').value,
                    NRTAREFACHK: Metadata.getInstance<SelectMultiple>('NRTAREFACHK').value,
                    NRCRITERIOTAREFACHK: tekGridCriteriosDeAvaliacaoCadastro.selectedRows.map((element: any) => element),
                    DATERANGE: (dataRange.length === 0) ? [data, data] : dataRange,
                    DIASEMANA: diaSemana,
                    OBSERVACOES: Metadata.getInstance<Select>('selectObservacoesObrigatorias').value,
                    EXECUTOR: this.executorHora(),
                    RECORRENCIA: Metadata.getInstance<Select>('select-recorrencia').value,
                    QTDDIAS: Metadata.getInstance<TextInput>('input-x-dias').value,
                    DTTERMINO: Metadata.getInstance<Date>('select-data-limite').value,
                };
                this.salvarVistoria(parametros, parametros.EXECUTOR);
            }
        } else {
            Utilities.alertMessage('Existem campos obrigatórios não preenchidos!', 'error');
        }
    }

    public salvarVistoria(parametros: any, executor: any) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-vistorias');

        LoadingService.show();
        Http.post('/insertVistoriaRecorrente', {
            NOMETAREFA: parametros.NOMETAREFA,
            CDCLIENTE: parametros.CDCLIENTE,
            NRTIPOLOCALCLI: parametros.NRTIPOLOCALCLI,
            NRLOCALCLIENTE: parametros.NRLOCALCLIENTE,
            NRCHECKLIST: parametros.NRCHECKLIST,
            NRATIVIDADECHK: parametros.NRATIVIDADECHK,
            NRESCOPOSTAREFA: parametros.NRESCOPOSTAREFA,
            NRTAREFACHK: parametros.NRTAREFACHK,
            NRCRITERIOTAREFACHK: parametros.NRCRITERIOTAREFACHK,
            DATERANGE: parametros.DATERANGE,
            DIASEMANA: parametros.DIASEMANA,
            OBSERVACOES: parametros.OBSERVACOES,
            EXECUTOR: executor,
            RECORRENCIA: parametros.RECORRENCIA,
            QTDDIAS: parametros.QTDDIAS,
            DTTERMINO: parametros.DTTERMINO,
        }).then(() => {
                Utilities.showSuccessMessage();
                this.fecharModalAdicionarVistoria();
                grid.datasource.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public onMountedTipoInsercao({ component }: IEventParam<Select>) {
        component.datasource.data = [];
        (component.datasource as MemoryDatasource).allData = [];

        const valores = [
            {
                name: 'Considerar todos os dias',
                value: 1,
            },
            {
                name: 'Considerar dias úteis (Criar Vistoria no próximo dia útil)',
                value: 2,
            },
            {
                name: 'Considerar dias úteis (Não criar Vistoria)',
                value: 3,
            },
        ];
        component.datasource.updateData(valores);
    }

    public executorHora() {
        const dados: any = [];
        const grid = Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');

        grid.datasource.data.forEach((element: any) => {
            dados.push({
                HORAINICIO: element.HORAINICIO,
                DURACAO: element.DURACAO,
                ENCARREGADO: element.ENCARREGADO,
                NRLOCALCLIENTE: element.NRLOCALCLIENTE,
                NRSEQCONTRATO: element.NRSEQCONTRATO,
                IDTIPOMARCACAOTAREFA: element.IDTIPOMARCACAOTAREFA,
                NRTIPOLOCALCLI: element.NRTIPOLOCALCLI,
                IGNORARTAREFA: 'N',
            });
        });
        return dados;
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formTarefas_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public async getParametrizacoes() {
        await Http.get('/getParametrizacoes').then((response) => {
            if (response.data.length > 0) {
                this.parametrizacoes = response.data;
            }
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        });
    }

    public changeRecorrencia({ component }: IEventParam<Select>) {
        const data = Metadata.getInstance<Data>('select-data');
        const xDias = Metadata.getInstance<TextInput>('input-x-dias');
        const periodo = Metadata.getInstance<DateRange>('select-periodo');
        const dtFinal = Metadata.getInstance<Data>('select-data-limite');

        switch (component.value) {
            case 'SR':
                this.disabledPeriodo = false;
                data.removeValidation('required');
                data.disabled = true;
                data.value = null;
                periodo.addValidation('required', {});
                xDias.disabled = true;
                xDias.value = null;
                dtFinal.value = null;
                dtFinal.removeValidation('required');
                dtFinal.disabled = true;
                break;
            case 'M':
                data.addValidation('required', {});
                this.disabledPeriodo = true;
                data.disabled = false;
                periodo.removeValidation('required');
                periodo.value = null;
                xDias.disabled = true;
                xDias.value = null;
                dtFinal.value = null;
                dtFinal.disabled = false;
                dtFinal.addValidation('required', {});
                break;
            case 'MP':
                periodo.addValidation('required', {});
                this.disabledPeriodo = false;
                data.disabled = true;
                data.removeValidation('required');
                data.value = null;
                xDias.disabled = true;
                xDias.value = null;
                dtFinal.value = null;
                dtFinal.disabled = false;
                dtFinal.addValidation('required', {});
                break;
            case 'Q':
                data.addValidation('required', {});
                this.disabledPeriodo = true;
                data.disabled = false;
                periodo.removeValidation('required');
                periodo.value = null;
                xDias.disabled = true;
                xDias.value = null;
                dtFinal.value = null;
                dtFinal.disabled = false;
                dtFinal.addValidation('required', {});
                break;
            case 'QP':
                periodo.addValidation('required', {});
                this.disabledPeriodo = false;
                data.disabled = true;
                data.removeValidation('required');
                data.value = null;
                xDias.disabled = true;
                xDias.value = null;
                dtFinal.value = null;
                dtFinal.disabled = false;
                dtFinal.addValidation('required', {});
                break;
            case 'S':
                data.addValidation('required', {});
                this.disabledPeriodo = true;
                data.disabled = false;
                periodo.removeValidation('required');
                periodo.value = null;
                xDias.disabled = true;
                xDias.value = null;
                dtFinal.value = null;
                dtFinal.disabled = false;
                dtFinal.addValidation('required', {});
                break;
            case 'SP':
                periodo.addValidation('required', {});
                this.disabledPeriodo = false;
                data.disabled = true;
                data.removeValidation('required');
                data.value = null;
                xDias.disabled = true;
                xDias.value = null;
                dtFinal.value = null;
                dtFinal.disabled = false;
                dtFinal.addValidation('required', {});
                break;
            case 'P':
                data.addValidation('required', {});
                this.disabledPeriodo = true;
                data.disabled = false;
                periodo.removeValidation('required');
                periodo.value = null;
                xDias.disabled = false;
                dtFinal.value = null;
                dtFinal.disabled = false;
                dtFinal.addValidation('required', {});
                break;
            default:
                break;
        }
    }

    public habilitarAcao({ component }: IEventParam<TekGrid>) {
        this.disabledPreencher = (component.selectedRows.length <= 0);
    }

    public operador: any = '';

    public focusEncarregado({ component }: any) {
        const grid = (this.modConflito) ? Metadata.getInstance<TekGrid>('tek-grid-conflito-datas') : Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');
        if (grid.editing) {
            component.datasource.setFilter({
                NRLOCALCLIENTE: Metadata.getInstance<Select>('NRLOCALCLIENTE').value,
            });
        }
    }

    public focusResponsavel({ component }: any) {
        component.datasource.setFilter({
            NRLOCALCLIENTE: Metadata.getInstance<Select>('NRLOCALCLIENTE').value,
        });
    }

    public validarGrid({ component }: IEventParam<TekGrid>) {
        if (component.isGridValid(true)) {
            Utilities.showSuccessMessage();
            this.editedRows = component.getEditedRows();
        } else {
            Utilities.alertMessage('Existem campos obrigatórios não preenchidos!', 'error');
        }
    }

    public defineVistoria() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');
        grid.datasource.data = [];
        (grid.datasource as MemoryDatasource).allData = [];

        const locais = Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').selectValue;
        locais.forEach((element: any) => {
            const dados: any = {
                NMLOCALCLIENTE: element.NMLOCALCLIENTE,
                NRLOCALCLIENTE: element.NRLOCALCLIENTE,
                NRESTRUTURAM: element.NRESTRUTURAM,
                NRTIPOLOCALCLI: element.NRTIPOLOCALCLI,
            };
            grid.datasource.post(dados);
        });
        grid.datasource.get();
        grid.columns[5].setLookupDataFilter({ NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').value });
    }

    public abrirModal() {
        this.abrirModalPreencherMassa();

        setTimeout(() => {
            Metadata.getInstance<Form>('form-preencher-massa').clearForm();
            //  trecho do modal de preenchimento em massa
            const hora = Metadata.getInstance<Time>('selectHoraInicio');
            const duracao = Metadata.getInstance<TextInput>('selectDuracao');
            const encarregado = Metadata.getInstance<Select>('ENCARREGADO');

            hora.disabled = false;
            // hora.removeValidation('required');
            duracao.disabled = false;
            duracao.removeValidation('required');
            duracao.removeValidation('minLength');

            encarregado.disabled = false;
           // encarregado.addValidation('required', {});
        }, 500);
    }

    public preencherGrid() {
        const form = Metadata.getInstance<Form>('form-preencher-massa');
        const grid = Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');
        const tipoMarcacao = Metadata.getInstance<Select>('IDTIPOMARCACAOTAREFA').value;
        const hora = Metadata.getInstance<Time>('selectHoraInicio').value;
        const duracao = Metadata.getInstance<TextInput>('selectDuracao').value;
        const encarregado = Metadata.getInstance<Select>('ENCARREGADO').value;

        grid.columns[6].setLookupDataFilter({ NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').value });
        if (Utilities.validateForm(form)) {
            grid.selectedRows.forEach((element: any) => {
                const newRow: any = {
                    ...element,
                    IDTIPOMARCACAOTAREFA: tipoMarcacao,
                    HORAINICIO: hora,
                    DURACAO: duracao,
                    ENCARREGADO: encarregado,
                };
                grid.datasource.put(newRow);
            });
            grid.datasource.get();
            grid.selectedRows = [];
            this.fecharModalPreencherMassa();
        }
    }

    public novoCriterio() {
        const gridCriterios = Metadata.getInstance<TekGrid>('tek-grid-criterios-de-avaliacao-cadastro');
        const editedRows = gridCriterios.getEditedRows();
        LoadingService.show();
        Http.post('/salvarNovoCriterioTekGrid', {
            ATIVIDADES: editedRows[0].NRTAREFACHK,
            NOME: editedRows[0].DSCRITERIOTAREFA,
        }).then(() => {
            Utilities.showSuccessMessage();
            gridCriterios.datasource.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public addNewRow({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRCRITERIOTAREFACHK: newId, IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`DSCRITERIOTAREFA_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public cancelAddNewRow({ component }: IEventParam<TekGrid>) {
        component.cancelEditedRows();
        component.editingNewRows = false;
    }
}
