import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import TeknisaComponents from '@zeedhi/teknisa-components-vuetify';
import TekLibComponents from '@zeedhi/tek-lib';
import { ZdCalendar } from '@zeedhi/zd-calendar';
import { Icons } from '@zeedhi/common';
import { Messages } from '@zeedhi/core';
import { ZdFieldGroup } from '@zeedhi/zd-field-group';
import { ZdQRCode } from '@zeedhi/zd-qrcode';
import { ZdRichText } from '@zeedhi/zd-richtext';
import { VueSpeechRecognition } from '@zeedhi/zd-speech-recognition';
import {
  ZdECharts, echartsCore, echartsCharts, echartsComponents,
} from '@zeedhi/zd-echarts';
import {
  ZdKanban, ZdKanbanColumn, ZdKanbanTask,
} from '@zeedhi/zd-kanban';
import router from '../router';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';

Icons.addIcons({
  iconName: 'mdi-icon-id',
});

Vue.use(Zeedhi, {
  controllers,
  router,
  config,
});

Vue.use(ZeedhiComponents);
Vue.use(TeknisaComponents);
Vue.use(TekLibComponents);

Vue.component('ZdCalendar', ZdCalendar);
Vue.component('ZdECharts', ZdECharts);
Vue.component('ZdKanban', ZdKanban);
Vue.component('ZdKanbanColumn', ZdKanbanColumn);
Vue.component('ZdKanbanTask', ZdKanbanTask);
Vue.component('ZdFieldGroup', ZdFieldGroup);
Vue.component('ZdQRCode', ZdQRCode);
Vue.component('ZdRichText', ZdRichText);
Vue.component('VueSpeechRecognition', VueSpeechRecognition);

echartsCore.use([
    echartsCharts.PieChart,
    echartsCharts.BarChart,
    echartsCharts.LineChart,
    echartsComponents.GridComponent,
]);

vuetify.framework.icons.values = Icons.getIcons() as any;

Messages.add({
  'pt-BR': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-CL': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-CO': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-ES': {
    translation: {
      KEY: 'valor',
    },
  },
  'en-US': {
    translation: {
      KEY: 'value',
    },
  },
});
